Educational Codeforces Round 6 C. Pearls in a Row(贪心)

Educational Codeforces Round 6C:http://codeforces.com/contest/620/problem/C

C. Pearls in a Row
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

There are n pearls in a row. Let's enumerate them with integers from 1 to n from the left to the right. The pearl number i has the type ai.

Let's call a sequence of consecutive pearls a segment. Let's call a segment good if it contains two pearls of the same type.

Split the row of the pearls to the maximal number of good segments. Note that each pearl should appear in exactly one segment of the partition.

As input/output can reach huge size it is recommended to use fast input/output methods: for example, prefer to use scanf/printfinstead of cin/cout in C++, prefer to use BufferedReader/PrintWriter instead of Scanner/System.out in Java.

Input

The first line contains integer n (1 ≤ n ≤ 3·105) — the number of pearls in a row.

The second line contains n integers ai (1 ≤ ai ≤ 109) – the type of the i-th pearl.

Output

On the first line print integer k — the maximal number of segments in a partition of the row.

Each of the next k lines should contain two integers lj, rj (1 ≤ lj ≤ rj ≤ n) — the number of the leftmost and the rightmost pearls in the j-th segment.

Note you should print the correct partition of the row of the pearls, so each pearl should be in exactly one segment and all segments should contain two pearls of the same type.

If there are several optimal solutions print any of them. You can print the segments in any order.

If there are no correct partitions of the row print the number "-1".

Sample test(s)
input
5
1 2 3 4 1
output
1
1 5
input
5
1 2 3 4 5
output
-1
input
7
1 2 1 3 1 2 1
output
2
1 3
4 7

题目大意:把一段项链,分成多小段,每一小段至少存在两个相同的类型的珍珠,求最多能分成多少段,如果不能分,则输出-1

大致思路:用map记录当前一段某类型的珍珠是否出现过,如果当前珍珠的类型已出现过,则将其与前面的珍珠分成一段。【注意】需特殊处理最后一段珍珠,让其结尾到项链尾部


#include <cstdio>
#include <cstring>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

int n,a[300005],i,pre,num;
vector<pair<int,int> > ans;
map<int,bool> vis;
bool flag=false;

int main() {
    scanf("%d",&n);
    for(i=1;i<=n;++i)
        scanf("%d",a+i);
    pre=1;
    for(i=1;i<=n;++i) {
        if(vis[a[i]]) {
            ans.push_back(make_pair(pre,i));
            vis.clear();
            pre=i+1;
        }
        else
            vis[a[i]]=true;
    }
    if(pre==1)
        printf("-1");
    else {
        printf("%d\n",num=ans.size());
        --num;
        for(i=0;i<num;++i)
            printf("%d %d\n",ans[i].first,ans[i].second);
        printf("%d %d\n",ans[num].first,n);
    }
    return 0;
}



你可能感兴趣的:(codeforces,贪心)